"use strickt";
/* 
 Теоретичні питання
 1. Опишіть своїми словами, що таке метод об'єкту
 2. Який тип даних може мати значення властивості об'єкта?
 3. Об'єкт це посилальний тип даних. Що означає це поняття?

 Практичні завдання
 1. Створіть об'єкт product з властивостями name, price та discount. Додайте метод для виведення повної ціни товару з урахуванням знижки. 
 Викличте цей метод та результат виведіть в консоль.
 
 2. Напишіть функцію, яка приймає об'єкт з властивостями name та age, і повертає рядок з привітанням і віком, 
 наприклад "Привіт, мені 30 років". Попросіть користувача ввести своє ім'я та вік 
 за допомогою prompt, і викличте функцію з введеними даними. Результат виклику функції виведіть з допомогою alert.

3.Опціональне. Завдання:
Реалізувати повне клонування об'єкта. 

Технічні вимоги:
- Написати функцію для рекурсивного повного клонування об'єкта (без єдиної передачі за посиланням, внутрішня вкладеність властивостей об'єкта може бути досить великою).
- Функція має успішно копіювати властивості у вигляді об'єктів та масивів на будь-якому рівні вкладеності.
- У коді не можна використовувати вбудовані механізми клонування, такі як функція Object.assign() або spread.
 */

// Практичне завдання 1

// const items = {
//   name: "phone",
//   price: 100,
//   discount: 30,
//   totalSum: function () {
//     discontValue = (this.discount / 100) * this.price;
//     return this.price - discontValue;
//   },
// };
// console.log(items.totalSum());

// Практичне завдання 2

// const info = function (user) {
//   return `Привіт, мені ${user.age} років , мене звуть ${user.name}.`;
// };
// const intoduction = function () {
//   const name = prompt("Введіть ваше ім'я");
//   const age = prompt("Введіть ваш вік");
//   const value = { age, name };
//   return info(value);
// };
// console.log(intoduction());

// Практичне завдання 3
// 3.Опціональне. Завдання:
// Реалізувати повне клонування об'єкта.
// Технічні вимоги:
// - Написати функцію для рекурсивного повного клонування об'єкта (без єдиної передачі за посиланням,
//   внутрішня вкладеність властивостей об'єкта може бути досить великою).
// - Функція має успішно копіювати властивості у вигляді об'єктів та масивів на будь-якому рівні вкладеності.
// - У коді не можна використовувати вбудовані механізми клонування, такі як функція Object.assign() або spread.

// let cloneObject;
// cloneObject = function (object) {
//   startobject(object);
// };
// let startobject = { name: "jack", age: "20" };

// for (const key in object) {
//   if (Object.hasOwnProperty.call(object, key)) {
//     const element = object[key];
//   }
// }
